"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.isUseSystemWine = isUseSystemWine;
exports.isUseSystemSigncode = isUseSystemSigncode;
exports.isBuildCacheEnabled = isBuildCacheEnabled;
exports.isAutoDiscoveryCodeSignIdentity = isAutoDiscoveryCodeSignIdentity;
function isUseSystemWine() {
    return isEnvTrue(process.env.USE_SYSTEM_WINE);
}
function isUseSystemSigncode() {
    return isEnvTrue(process.env.USE_SYSTEM_SIGNCODE);
}
function isBuildCacheEnabled() {
    return !isEnvTrue(process.env.ELECTRON_BUILDER_DISABLE_BUILD_CACHE);
}
function isAutoDiscoveryCodeSignIdentity() {
    return process.env.CSC_IDENTITY_AUTO_DISCOVERY !== "false";
}
function isEnvTrue(value) {
    if (value != null) {
        value = value.trim();
    }
    return value === "true" || value === "" || value === "1";
}
//# sourceMappingURL=flags.js.map