"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.computeLicensePage = undefined;

var _bluebirdLst;

function _load_bluebirdLst() {
    return _bluebirdLst = require("bluebird-lst");
}

let computeLicensePage = exports.computeLicensePage = (() => {
    var _ref = (0, (_bluebirdLst || _load_bluebirdLst()).coroutine)(function* (packager, options) {
        const possibleFiles = [];
        for (const name of ["license", "eula"]) {
            for (const ext of ["rtf", "txt", "html"]) {
                possibleFiles.push(`${name}.${ext}`);
                possibleFiles.push(`${name.toUpperCase()}.${ext}`);
                possibleFiles.push(`${name}.${ext.toUpperCase()}`);
                possibleFiles.push(`${name.toUpperCase()}.${ext.toUpperCase()}`);
            }
        }
        const license = yield packager.getResource.apply(packager, [options.license].concat(possibleFiles));
        if (license != null) {
            let licensePage;
            if (license.endsWith(".html")) {
                licensePage = ["!define MUI_PAGE_CUSTOMFUNCTION_SHOW LicenseShow", "Function LicenseShow", "  FindWindow $R0 `#32770` `` $HWNDPARENT", "  GetDlgItem $R0 $R0 1000", "EmbedHTML::Load /replace $R0 file://$PLUGINSDIR\\license.html", "FunctionEnd", `!insertmacro MUI_PAGE_LICENSE "${_path.join((_nsisUtil || _load_nsisUtil()).nsisTemplatesDir, "empty-license.txt")}"`];
            } else {
                licensePage = [`!insertmacro MUI_PAGE_LICENSE "${license}"`];
            }
            let result = (0, (_nsisUtil || _load_nsisUtil()).createMacro)("licensePage", licensePage);
            if (license.endsWith(".html")) {
                result += "\n" + (0, (_nsisUtil || _load_nsisUtil()).createMacro)("addLicenseFiles", [`File /oname=$PLUGINSDIR\\license.html "${license}"`]);
            }
            return result;
        }
        const licenseFiles = yield (0, (_license || _load_license()).getLicenseFiles)(packager);
        if (licenseFiles.length === 0) {
            return null;
        }
        const licensePage = [];
        const unspecifiedLangs = new Set((_license || _load_license()).bundledLanguages);
        let defaultFile = null;
        for (const item of licenseFiles) {
            unspecifiedLangs.delete(item.langWithRegion);
            if (defaultFile == null) {
                defaultFile = item.file;
            }
            licensePage.push(`LicenseLangString MUILicense ${(_license || _load_license()).lcid[item.langWithRegion] || item.lang} "${item.file}"`);
        }
        for (const l of unspecifiedLangs) {
            licensePage.push(`LicenseLangString MUILicense ${(_license || _load_license()).lcid[l]} "${defaultFile}"`);
        }
        licensePage.push('!insertmacro MUI_PAGE_LICENSE "$(MUILicense)"');
        return (0, (_nsisUtil || _load_nsisUtil()).createMacro)("licensePage", licensePage);
    });

    return function computeLicensePage(_x, _x2) {
        return _ref.apply(this, arguments);
    };
})();
//# sourceMappingURL=nsisLicense.js.map


var _path = _interopRequireWildcard(require("path"));

var _license;

function _load_license() {
    return _license = require("../license");
}

var _nsisUtil;

function _load_nsisUtil() {
    return _nsisUtil = require("./nsisUtil");
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }