"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.EXEC_TIMEOUT = undefined;
exports.computeEnv = computeEnv;
exports.computeToolEnv = computeToolEnv;
exports.getLinuxToolsPath = getLinuxToolsPath;

var _binDownload;

function _load_binDownload() {
    return _binDownload = require("electron-builder-util/out/binDownload");
}

// 2 minutes
const EXEC_TIMEOUT = exports.EXEC_TIMEOUT = { timeout: 120 * 1000 };
/** @internal */
function computeEnv(oldValue, newValues) {
    const parsedOldValue = oldValue ? oldValue.split(":") : [];
    return newValues.concat(parsedOldValue).filter(it => it.length > 0).join(":");
}
/** @internal */
function computeToolEnv(libPath) {
    // noinspection SpellCheckingInspection
    return Object.assign({}, process.env, { DYLD_LIBRARY_PATH: computeEnv(process.env.DYLD_LIBRARY_PATH, libPath) });
}
/** @private */
function getLinuxToolsPath() {
    //noinspection SpellCheckingInspection
    return (0, (_binDownload || _load_binDownload()).getBinFromGithub)("linux-tools", "mac-10.12", "DowDogHsS6X4a5au4r8T8qYprf7hqjfzcU7DL5oiD43jhZMfkQOjmFFYC1s7Lp9ARXp+sm8OJhuwaqCHMVGZYg==");
}
//# sourceMappingURL=bundledTool.js.map